<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8" isELIgnored="false" session="false"%>
<%@ include file="/WEB-INF/jsp/include/taglib.jsp"%>

<!-- inner page html -->
<div class="content-pop">
	<!-- Content -->
	<div class="container flex-grow-1 px-0">
		<c:set var="prefixName" scope="request">감액 정보</c:set>

		<!-- Page Body -->
		<div class="card">
			<!-- 입력 영역 -->
			<form id="frmEdit--${pageName}" name="frmEdit">
				<!-- hidden -->
				<input type="hidden" id="crdnId--${pageName}" name="crdnId" data-map="CRDN_ID" />
				<input type="hidden" id="sggCd--${pageName}" name="sggCd" data-map="SGG_CD" />
				<input type="hidden" id="taskSeCd--${pageName}" name="taskSeCd" data-map="TASK_SE_CD" />
				<input type="hidden" id="levyExclId--${pageName}" name="levyExclId" data-map="LEVY_EXCL_ID" />

				<div class="row g-1">
					<!-- 단속일시 -->
					<div class="col-md-12">
						<label for="crdnYmdTm--${pageName}" class="w-px-120 bg-lighter pe-2 col-form-label text-sm-end">단속일시</label>
						<input type="text" class="form-control w-35" id="crdnYmdTm--${pageName}" name="crdnYmdTm" data-map="CRDN_YMD_TM" data-fmt-type="dt" />
					</div>
					<!-- 차량번호 -->
					<div class="col-md-12">
						<label for="vhrno--${pageName}" class="w-px-120 bg-lighter pe-2 col-form-label text-sm-end">차량번호</label>
						<input type="text" class="form-control w-px-120" id="vhrno--${pageName}" name="vhrno" data-map="VHRNO" autocomplete="off" />
					</div>
					<!-- 부과 제외 구분 -->
					<div class="col-md-12">
						<label for="levyExclSeNm--${pageName}" class="w-px-120 bg-lighter pe-2 col-form-label text-sm-end required">부과제외구분</label>
						<input type="text" class="form-control w-px-120" id="levyExclSeNm--${pageName}" autocomplete="off" />
						<input type="hidden" id="levyExclSeCd--${pageName}" name="levyExclSeCd" data-map="LEVY_EXCL_SE_CD" />
					</div>
					<!-- 부과 제외 일자 -->
					<div class="col-md-12">
						<label for="levyExclYmd--${pageName}" class="w-px-120 bg-lighter pe-2 col-form-label text-sm-end required">부과제외일자</label>
						<input type="text" class="form-control form-date" id="levyExclYmd--${pageName}" name="levyExclYmd" data-map="LEVY_EXCL_YMD"
							data-fmt-type="day" autocomplete="off" title="날짜 선택" maxlength="10" required />
						<button type="button" class="bx bx-lg bx-calendar bg-white" id="btnLevyExclYmd--${pageName}"></button>
					</div>
					<!-- 부과 제외 사유 -->
					<div class="col-md-12">
						<label for="levyExclRsnCd--${pageName}" class="w-px-120 bg-lighter pe-2 col-form-label text-sm-end required">부과제외사유</label>
						<select class="form-select" id="levyExclRsnCd--${pageName}" name="levyExclRsnCd" data-map="LEVY_EXCL_RSN_CD" required>
							<option value="">선택하세요</option>
							<c:forEach items="${FIM022List}" var="item">
								<option value="${item.code}">${item.value}</option>
							</c:forEach>
						</select>
					</div>
					<!-- 기타 내용 -->
					<div class="col-md-12">
						<label for="etcCn--${pageName}" class="w-px-120 bg-lighter pe-2 col-form-label text-sm-end">기타 내용</label>
						<textarea type="text" class="form-control w-70" id="etcCn--${pageName}" name="etcCn" data-map="ETC_CN" autocomplete="off" rows="3" data-maxlengthb="1000"></textarea>
					</div>
				</div>
			</form> <!-- /입력 영역 -->
		</div> <!-- <div class="card"> -->

		<!-- 업무 버튼 표시 -->
		<div>
			<span class="container-page-btn">
				<span class="container-window-btn-right">
					<!-- 업무 버튼 -->
					<button type="button" class="btn btn-primary w-px-80" id="btnSave--${pageName}" title="저장">
						저장
					</button>
				</span>
			</span>
		</div>
		<!-- / 업무 버튼 표시 -->

	</div> <!-- / Content <div class="container flex-grow-1 px-0"> -->
</div> <!-- / inner page html <div class="content-pop"> -->

<script>
	/**************************************************************************
	 * Global Variable
	 **************************************************************************/
	pageObject["${pageName}"] = {};

 	// infoDialog 호출 용도(view 조회(편집불가), create 등록, update 수정)
	var ${pageName}CallPurpose = "${callPurpose}";

 	// 공통 코드
	var FIM021 = new CommonCodes(${FIM021}, true);
	var FIM022 = new CommonCodes(${FIM022}, true);

	/**************************************************************************
	 * script 진입
	 **************************************************************************/
	$(document).ready(function() {
		// pageObject
		var $P = pageObject["${pageName}"];

		// URL
		$P.PrefixUrl = "/excl/excl01";
		// FormFields
	 	$P.formFields = new FimsFormFields("#frmEdit--${pageName}");

		/**************************************************************************
		 * DatasetControl
		 **************************************************************************/
		$P.control = new DatasetControl({
			  prefix : "levyExcl"
			, prefixName : "부과제외"
			, keymapper : info => info ? info.LEVY_EXCL_ID : ""
			, dataGetter : obj => obj.levyExclInfo
			, urls : {
				  create : wctx.url("/" + $P.PrefixUrl + "/020/create.do")		// 등록
				, update : wctx.url("/" + $P.PrefixUrl + "/020/update.do")		// 수정
			}
		});

		/**************************************************************************
		 * DatasetControl 이벤트
		 **************************************************************************/
		 $P.control.onCurrentChange = item => {
			if (!item) return;

			// Dataset 셋팅
			$P.formFields.set($P.control,item);

			// 업무구분에 따른 URL 변경
			$P.setURL(item.data.TASK_SE_CD);

			// 부과제외구분에 따른 부과제외사유 설정
			$P.setFim021(item.data.LEVY_EXCL_SE_CD, item.data.LEVY_EXCL_RSN_CD);

			// 호출용도가 등록 이라면..
			if (${pageName}CallPurpose = "create") {
			    $("#levyExclYmd--${pageName}").datepicker("setDate", new Date());
			}
		}

		// 저장 callback
		$P.control.onSave = (resp) => {
			let dialogTitle = $("#" + $P.control.prefix + "Dialog").find("h5.modal-title").html();
			let showMessage = resp.rtnMsg.replace(/[S]|[F]/g, dialogTitle);

			// 메시지 출력
			dialog.alert({
				  content : showMessage
				, onOK : () => { }
			});

			if (resp.saved) {
				dialog.close($P.control.prefix + "Dialog");

				if ("${savedCallbackFuncName}" != "") {
					${savedCallbackFuncName}(resp.saved);
				}
			}
		}

		// 저장
		$P.control.save = (info) => {
			if (!info) return;

	  		let create = isEmpty(info.levyExclId);

	  		// 민원 접수 관리에서 호출했다면..
			if (create && "${saveCallbackFuncName}" != "") {
				${saveCallbackFuncName}(info);
			} else {
				ajax.post({
					  url : !create ? $P.control.urls.update : $P.control.urls.create
					, data : info
					, success : resp => $P.control.onSave(resp)
				});
			}
		}

		/**************************************************************************
		 * 사용자 함수(function)
		 **************************************************************************/
		// 부과제외 구분에 따른 부과제외 사유 코드 설정
		$P.setFim021 = (seCode, rsnCode) => {
			let cmnCode = FIM021[seCode];

			$("#levyExclSeCd--${pageName}").val(cmnCode.code);
			$("#levyExclSeNm--${pageName}").val(cmnCode.value);

			let reasons = FIM022.list().filter(reason => "2" == seCode ? reason.code > "200" : reason.code < "200");
			$("#levyExclRsnCd--${pageName}").html(reasons.map(reason => "<option value='" + reason.code + "'>" + reason.value + "</option>").join());

			if (typeof rsnCode != "undefined" && rsnCode != "") {
				$("#levyExclRsnCd--${pageName}").val(rsnCode);
			}
		}

		/**************************************************************************
		 * 버튼 clickEvent
		 **************************************************************************/
		// 저장 버튼 클릭 이벤트
		$P.fnSave = () => {
			// validate 확인
			if (!AppSupport.customValidate($("#frmEdit--${pageName}").find("input, select, textarea"))) return;

			dialog.alert({
				  content : "현재 " + $P.control.prefixName + " 정보를 저장하시겠습니까?"
				, onOK : () => {
					$P.control.save($P.formFields.get());
				}
			});
		}

		/**************************************************************************
		 * 초기 셋팅
		 **************************************************************************/
		// 이벤트 설정
		$P.setEvent = () => {
			// form-date 항목에서 키보드로 입력시 날짜 포맷팅 적용
			$("#frmEdit--${pageName}").find(".form-date").each(function() {
				$(this).on("input", function() {
					let value = this.value.replaceAll("-","");

					if (value.length > 7) {
						this.value = value.substring(0, 4) + "-" + value.substring(4, 6) + "-" + value.substring(6);
					} else if(value.length > 5) {
						this.value = value.substring(0, 4) + "-" + value.substring(4);
					}
				});
			});

			// 업무 버튼 이벤트
			$("#btnSave--${pageName}").on("click", () => $P.fnSave());		// 저장
		}

		// 초기 화면 설정
		$P.initForm = () => {


			// 달력 초기화
		    AppSupport.initDatepicker("frmEdit--${pageName}");
		    $("#levyExclYmd--${pageName}").datepicker("setDate", new Date());

		    // 화면 활성화 설정
			$("#crdnYmdTm--${pageName}").prop("readonly", true);		// 단속 일시
			$("#vhrno--${pageName}").prop("readonly", true);			// 차량번호
			$("#levyExclSeNm--${pageName}").prop("readonly", true);		// 부과 제외 구분

			if (${pageName}CallPurpose == "view") {
				// input 요소들을 disabled
				$("#frmEdit--${pageName}").find("input,textarea,select").prop("disabled", true);
				// button 요소들을 disabled
				$("#btnLevyExclYmd--${pageName}").prop("disabled", true);		// 부과제외 일자 달력 버튼
				$("#btnSave--${pageName}").prop("disabled", true);				// 저장 버튼
			}
		}

		// 업무구분에 따른 URL 설정
		$P.setURL = (taskSeCd) => {
			$P.control.urls.create = wctx.url($P.PrefixUrl + "/020/create.do");		// 등록
			$P.control.urls.update = wctx.url($P.PrefixUrl + "/020/update.do");		// 수정
		}

		/**************************************************************************
		 * 최초 실행 함수
		 **************************************************************************/
		// 1. 이벤트 설정
		$P.setEvent();

		// 2. 초기 화면 설정
		$P.initForm();

		// 3. Dataset 설정
		$P.control.setData([${levyExclInfo}]);
	});

</script>
